
-- Selection of a recipe by name (e.g. 'Kartoffelpuffer' here) #9
SELECT *
FROM REZEPT
WHERE `NAME` = 'Kartoffelpuffer';

-- Selection of a recipe of a certain nutritional category #10
SELECT REZEPT.*
FROM REZEPT
INNER JOIN REZEPTERNAEHRUNGSKATEGORIE RE on RE.REZEPTNR = REZEPT.REZEPTNR
INNER JOIN ERNAEHRUNGSKATEGORIE E on RE.ERNAEHRUNGSKATEGORIENR = E.ERNAEHRUNGSKATEGORIENR
WHERE E.NAME = 'Frutarisch';

-- Selection of a recipe by predetermined nutritional categories (example data in brackets) #6
SELECT R.*
FROM REZEPT R
INNER JOIN REZEPTERNAEHRUNGSKATEGORIE RE on RE.REZEPTNR = R.REZEPTNR
INNER JOIN ERNAEHRUNGSKATEGORIE E on RE.ERNAEHRUNGSKATEGORIENR = E.ERNAEHRUNGSKATEGORIENR
WHERE E.NAME in ('Vegan', 'Frutanisch')
GROUP BY R.REZEPTNR
HAVING COUNT(R.REZEPTNR) = 2;

-- Selection of all recipes by specific ingredients (in this example Tomate) #11
SELECT R.*
FROM REZEPT R
INNER JOIN REZEPTZUTAT RZ on RZ.REZEPTNR = R.REZEPTNR
INNER JOIN ZUTAT Z on RZ.ZUTATENNR = Z.ZUTATENNR
WHERE Z.BEZEICHNUNG = 'Tomate';

-- Selection of all recipes by excluding an allergen (example data in brackets) #7
SELECT DISTINCT R.*
FROM REZEPT R
LEFT JOIN REZEPTALLERGEN RA on RA.REZEPTNR = R.REZEPTNR
LEFT JOIN ALLERGEN A on RA.ALLERGENNR = A.ALLERGENNR
WHERE RA.ALLERGENNR is null
   OR A.NAME not in ('Laktose');

-- Compilation of ingredients according to a recipe #5
SELECT Z.ZUTATENNR, Z.BEZEICHNUNG, RZ.MENGE, Z.EINHEIT
FROM ZUTAT Z
INNER JOIN REZEPTZUTAT RZ on Z.ZUTATENNR = RZ.ZUTATENNR
INNER JOIN REZEPT R on RZ.REZEPTNR = R.REZEPTNR
WHERE R.NAME = 'Kartoffelpuffer';

-- Selection of all ingredients that have not yet been assigned to a recipe #13
SELECT Z.*
FROM ZUTAT Z
LEFT JOIN REZEPTZUTAT RZ on Z.ZUTATENNR = RZ.ZUTATENNR
WHERE RZ.REZEPTNR is null;

-- Calculation of the average nutritional values ​​of all orders placed by a customer #12
SELECT AVG(Z.KALORIEN * BZ.MENGE) 'AVG_KALORIEN', AVG(Z.KOHLENHYDRATE * BZ.MENGE) 'AVG_KOHLENHYDRATE', AVG(Z.PROTEIN * BZ.MENGE) 'AVG_PROTEIN'
FROM ZUTAT Z
INNER JOIN BESTELLUNGZUTAT BZ on Z.ZUTATENNR = BZ.ZUTATENNR
INNER JOIN BESTELLUNG B on BZ.BESTELLNR = B.BESTELLNR
INNER JOIN KUNDE K on B.KUNDENNR = K.KUNDENNR
WHERE B.KUNDENNR = 2003;

-- Implement a query with aggregate functions #32
SELECT SUM(Z.NETTOPREIS * RZ.MENGE) 'REZEPT_NETTOPREIS'
FROM ZUTAT Z
INNER JOIN REZEPTZUTAT RZ on Z.ZUTATENNR = RZ.ZUTATENNR
INNER JOIN REZEPT R on RZ.REZEPTNR = R.REZEPTNR
WHERE R.NAME = 'Kartoffelpuffer';

-- Implement a query with subselects #31
SELECT L.LIEFERANTENNR, L.LIEFERANTENNAME
FROM LIEFERANT L
WHERE EXISTS (
    SELECT Z.*
    FROM ZUTAT Z
    WHERE Z.LIEFERANT = L.LIEFERANTENNR
        AND Z.BESTAND <= 20
    );

-- Selection of orders with the delivery address only #14
SELECT B.BESTELLNR, KU.STRASSE, KU.HAUSNR, KU.PLZ, KU.ORT
FROM KUNDE KU
INNER JOIN BESTELLUNG B on KU.KUNDENNR = B.KUNDENNR;

-- Selection of ordered and stored amount of goods #14
SELECT Z.ZUTATENNR, Z.BEZEICHNUNG, BE.MENGE, Z.BESTAND, Z.EINHEIT
FROM ZUTAT Z
INNER JOIN BESTELLUNGZUTAT BE on BE.ZUTATENNR = Z.ZUTATENNR;

-- Selection of Customers sorted by highest income #14
SELECT BE.KUNDENNR, KU.VORNAME, KU.NACHNAME, SUM(BE.RECHNUNGSBETRAG) SUMME
FROM BESTELLUNG BE
INNER JOIN KUNDE KU on BE.KUNDENNR = KU.KUNDENNR
GROUP BY BE.KUNDENNR
ORDER BY SUM(BE.RECHNUNGSBETRAG) DESC;

-- inner join: Customers who have ordered something #29
SELECT KUNDE.VORNAME, KUNDE.NACHNAME, BESTELLUNG.BESTELLNR
FROM BESTELLUNG
INNER JOIN KUNDE on BESTELLUNG.KUNDENNR = KUNDE.KUNDENNR

-- left join: Suppliers who do not supply any goods #30
SELECT L.*
FROM LIEFERANT L
LEFT JOIN ZUTAT Z on L.LIEFERANTENNR = Z.LIEFERANT
WHERE Z.LIEFERANT is null;

-- right join: Ingredients which have never been bought before #39
SELECT Z.*
FROM BESTELLUNGZUTAT BZ
RIGHT JOIN ZUTAT Z on BZ.ZUTATENNR = Z.ZUTATENNR
WHERE BZ.ZUTATENNR is null
